using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;

using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;
using System.Xml.Serialization;
using mapDll;

namespace CS_Map_Builder
{
    public partial class Form1 : Form
    {
        ArrayList serialList = new ArrayList();
        mapLocation last;
        public mapLocation head;
        public ArrayList mapLocations;
        public ArrayList quests;
        bool selectMode = false;
        public Form1()
        {
            mapLocations = new ArrayList();
            quests = new ArrayList();
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Form form = new Form2(this);
            form.Show();
            this.Enabled = false;
        }

        private void deleteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //This crazy stuff kills the picturebox and removes the quest from the list!

            Control test = ((ContextMenuStrip)((ToolStripDropDownItem)sender).Owner).SourceControl;
            mapLocations.Remove(test);
            test.Dispose();
        }

        private void connectToolStripMenuItem_Click(object sender, EventArgs e)
        {
            mapLocation tempLoc = (mapLocation)((((PictureBox)((ContextMenuStrip)((ToolStripDropDownItem)sender).Owner).SourceControl).DataBindings[0]).DataSource);

            if (selectMode == true)
            {
                if (tempLoc.connections.Contains(last) == false && tempLoc != last && last != null)
                    tempLoc.connections.Add(last);
                selectMode = false;
                last = null;
                this.Text = "CS Map Editer";
                contextMenuStrip1.Items[2].Text = "Connect";
                connectNodes();
            }
            else
            {
                last = (mapLocation)((((PictureBox)((ContextMenuStrip)((ToolStripDropDownItem)sender).Owner).SourceControl).DataBindings[0]).DataSource);
                selectMode = true;
                this.Text = "Select the node to connect to. Select same node to cancel.";
                contextMenuStrip1.Items[2].Text = "Connect to this node.";
            }
        }


        private void addLocationToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form2 form = new Form2(this);
            form.Show();
            form.textBox2.Text = (pictureBox1.PointToClient(MousePosition).X - 20).ToString();
            form.textBox3.Text = (pictureBox1.PointToClient(MousePosition).Y - 20).ToString();
            this.Enabled = false;
        }

        private void connectNodes()
        {
            foreach (PictureBox x in pictureBox1.Controls)
            {
                foreach (mapLocation y in ((mapLocation)(x.DataBindings[0].DataSource)).connections)
                {
                    Graphics g = pictureBox1.CreateGraphics();
                    Pen thickPen = new Pen(Brushes.Black, 5f);
                    g.DrawLine(thickPen, x.Location, y.location);
                    g.Dispose();
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            saveFileDialog1.Title = "Specify Destination Filename";
            saveFileDialog1.Filter = "CS Map Files |*.csm";
            saveFileDialog1.FilterIndex = 1;
            saveFileDialog1.OverwritePrompt = true;

            if (saveFileDialog1.ShowDialog() != DialogResult.Cancel)
            {                
                serialList.Add(pictureBox1.Image);
                serialList.Add(mapLocations);
                Stream stream = new FileStream(saveFileDialog1.FileName, System.IO.FileMode.Create);
                IFormatter formatter = new BinaryFormatter();
                formatter.Serialize(stream, serialList);
                stream.Close();
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "CS Map files |*.csm";
            if (openFileDialog1.ShowDialog() != DialogResult.Cancel)
            {
                Stream stream = new FileStream(openFileDialog1.FileName, System.IO.FileMode.Open);
                IFormatter formatter = new BinaryFormatter();
                ArrayList itemsDeserialized = (ArrayList)formatter.Deserialize(stream);
                mapLocations.Clear();
                pictureBox1.Image = (Image)itemsDeserialized[0];
                foreach (mapLocation x in (ArrayList)itemsDeserialized[1])
                {
                    mapLocations.Add(x);
                    x.makeBox(pictureBox1,contextMenuStrip1,toolTip1);
                }
                stream.Close();
            }


        }

        private void button4_Click(object sender, EventArgs e)
        {
            Form4 form4 = new Form4(this);
            form4.Show();
            this.Enabled = false;
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            saveFileDialog1.Title = "Specify Destination Filename";
            saveFileDialog1.Filter = "CS Quest Files |*.csq";
            saveFileDialog1.FilterIndex = 1;
            saveFileDialog1.OverwritePrompt = true;

            if (saveFileDialog1.ShowDialog() != DialogResult.Cancel)
            {
                Stream stream = new FileStream(saveFileDialog1.FileName, System.IO.FileMode.Create);
                IFormatter formatter = new BinaryFormatter();
                formatter.Serialize(stream, quests);
                stream.Close();
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "CS Quest Files |*.csq";
            if (openFileDialog1.ShowDialog() != DialogResult.Cancel)
            {
                Stream stream = new FileStream(openFileDialog1.FileName, System.IO.FileMode.Open);
                IFormatter formatter = new BinaryFormatter();
                ArrayList itemsDeserialized = (ArrayList)formatter.Deserialize(stream);
                quests.Clear();
                foreach (Quest x in itemsDeserialized)
                {
                    quests.Add(x);
                }
                stream.Close();
            }
        }

        private void addQuestToolStripMenuItem_Click(object sender, EventArgs e)
        {
            mapLocation tempLoc = (mapLocation)((((PictureBox)((ContextMenuStrip)((ToolStripDropDownItem)sender).Owner).SourceControl).DataBindings[0]).DataSource);
            Form5 form5 = new Form5(this,tempLoc);
            form5.Show();
            this.Enabled = false;
        }

        private void viewQuestsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            mapLocation tempLoc = (mapLocation)((((PictureBox)((ContextMenuStrip)((ToolStripDropDownItem)sender).Owner).SourceControl).DataBindings[0]).DataSource);
            Form6 form6 = new Form6(this,tempLoc);
            form6.Show();
            this.Enabled = false;
        }

        private void button6_Click(object sender, EventArgs e)
        {
            connectNodes();
        }
    }
}