using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
namespace CS_Map_Builder
{
    [Serializable]
    public class mapLocation
    {
        Image Circle = CS_Map_Builder.Properties.Resources.Circle;
        Image Square = CS_Map_Builder.Properties.Resources.Square;

        public String name;  // location name
        public String type;  // location type: town, tower, quest
        public String description; //location description

        public ArrayList quests;  // list of quests for this location
        public ArrayList connections; //nodes this node points to

        public Point location;
        public mapLocation()
        {
            connections = new ArrayList();
            quests = new ArrayList();
        }
        public void makeBox(PictureBox pictureBox, ContextMenuStrip context, ToolTip toolTip)
        {
            PictureBox newLoc = new PictureBox();
            newLoc.DataBindings.Add("", this, "");
            newLoc.Parent = pictureBox;
            newLoc.ContextMenuStrip = context;
            toolTip.SetToolTip(newLoc, name);
            newLoc.Name = name;
            newLoc.Location = location;
            newLoc.Size = new Size(20, 20);
            newLoc.BackColor = Color.Transparent;
            newLoc.SizeMode = PictureBoxSizeMode.StretchImage;
            switch (type)
            {
                case "Town":
                    newLoc.Image = Square;
                    break;
                case "Quest":
                    newLoc.Image = Circle;
                    break;
                case "Tower":
                    newLoc.Image = Circle;
                    break;
                default:
                    MessageBox.Show("Quest Type Error! " + type);
                    break;
            }
            //Click += new System.EventHandler(this.clicked);
        }
        public void setToolandContext(ToolTip toolTip, ContextMenuStrip contextMenuStrip)
        {
            //toolTip.SetToolTip(this, name);
            //this.ContextMenuStrip = contextMenuStrip;
        }

        void clicked(object sender, EventArgs e)
        {
            MessageBox.Show("click!");
        }

    }
}
