using System;
using System.Collections.Generic;
using System.Text;
using System.Security;
using System.Security.Permissions;
using System.Security.Policy;
using System.Reflection;
using System.IO;
using System.Diagnostics;
using System.Collections.Specialized;

namespace CSTextEditor
{        
    public class CSCompiler
    {
        public String text;
        public string[] references;
        public CSCompiler(String code)
        {
            this.text = code;
            references = new string[] { "System.dll", "System.Windows.Forms.dll" };
        }
        public CSCompiler()
        { }
        private Assembly cachedScriptAssembly = null;

        public void Compile(CompilerOutputDelegate cod)
        {
            try
            {
                cachedScriptAssembly = CodeCompile.DefaultCompiler.Compile(this, cod).CompiledAssembly;
            }
            catch (System.IO.FileNotFoundException exp)
            {
                throw new Exception("Unable to load script assembly (probably a complier error, check debug output)", exp);
            }
        }

        public void Run(CompilerOutputDelegate cod, object subject, object[] parameters)
        {
            this.Run(cod, subject, parameters, GetDefaultScriptPermissionSet());
        }

        public void Run(CompilerOutputDelegate cod, object subject, object[] parameters, PermissionSet permissionSet)
        {
            if (cachedScriptAssembly == null)
            {
                // compile if necessary
                cachedScriptAssembly = CodeCompile.DefaultCompiler.Compile(this, cod).CompiledAssembly;
            }


            if (cachedScriptAssembly != null)
            {
                // run script
                //this.cachedScriptAssembly.GetType( Template.ScriptClassName ).GetMethod( Template.ScriptMainMethodName ).Invoke(subject, parameters);

                Process process = new Process();
                process.StartInfo.FileName = cachedScriptAssembly.Location;
                process.Start();

                //Mike: Why was I doing this to myself?
                //Mike: This code will execute the users code inside the form.
                //Mike: This is useful for testing input and the script game.

                /*TextWriter holdConsoleOut = Console.Out;
                StringWriter stringWriter = new StringWriter();
                Console.SetOut(stringWriter);

                // restrict code security
                permissionSet.PermitOnly();
                // run code at entry point
                this.cachedScriptAssembly.EntryPoint.Invoke(subject, parameters);
                
                // revert security restrictions
                CodeAccessPermission.RevertPermitOnly();

                cod(stringWriter.ToString());

                stringWriter.Close();
                Console.SetOut(holdConsoleOut);
                */
            }
        }

        public static PermissionSet GetDefaultScriptPermissionSet()
        {
            PermissionSet internalDefScriptPermSet = new PermissionSet(PermissionState.None);
            internalDefScriptPermSet.AddPermission(new SecurityPermission(SecurityPermissionFlag.Execution));
            internalDefScriptPermSet.AddPermission(new ReflectionPermission(ReflectionPermissionFlag.MemberAccess));

            return internalDefScriptPermSet;
        }
    }
}
